<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The irrigation data is used to compute the nutrients provided by the water.</translate>
          </q-banner>

          <q-card-section>
            <q-select
              v-model="storeIrrigationClimateZone"
              :label="$gettext('Climate zone')"
              :options="climateZoneOptions"
              option-value="id"
              option-label="name"
              filled
              :loading="loading"
              @update:model-value="onClimateZoneChange"
              class="q-mt-md"
            >
              <template #after>
                <q-icon
                  name="las la-info-circle"
                  @click="onClickClimateZoneInfo"
                />
              </template>
            </q-select>

            <div class="row q-gutter-md q-mt-none">
              <q-input
                v-model.number="storeIrrigationAnnualRainfall"
                filled
                type="number"
                :label="$gettext('Annual rainfall')"
                :suffix="$gettext('mm')"
                :rules="[val => val >= 0 || $gettext('This field value must be between positive or null')]"
                :min="0"
                :loading="loading"
                step="1"
                hide-bottom-space
                class="col"
              />
              <q-input
                v-model.number="storeIrrigationAutumnWinterRainfall"
                filled
                type="number"
                :label="$gettext('Autumn-winter rainfall')"
                :suffix="$gettext('mm')"
                :rules="[
                  val => val >= 0 || $gettext('This field value must be between positive or null'),
                  val => checkAutomnWinterRainfall(val)
                ]"
                :min="0"
                :loading="loading"
                step="1"
                hide-bottom-space
                class="col"
              />
            </div>
          </q-card-section>

          <q-card-section
            v-if="waterSupplyOptions && waterSupplyOptions.length"
            class="q-py-none"
          >
            <q-field
              :label="$gettext('Water supply')"
              stack-label
              borderless
              class="q-pa-none"
            >
              <template #control>
                <q-btn-toggle
                  v-model="storeIrrigationWaterSupply"
                  :options="waterSupplyOptions"
                  toggle-color="primary"
                  spread
                  class="q-mt-sm col-grow"
                />
              </template>
            </q-field>
          </q-card-section>

          <q-card-section
            v-if="hasIrrigation"
          >
            <q-select
              v-model="storeIrrigationType"
              :label="$gettext('Irrigation type')"
              :options="irrigationTypeOptions"
              option-value="name"
              option-label="description"
              filled
              :loading="loading"
            />
            <div class="row q-gutter-md q-mt-none">
              <q-input
                v-model.number="storeIrrigationDose"
                filled
                type="number"
                :label="$gettext('Irrigation dose / year')"
                :suffix="irrigationDoseUnitDisplay"
                :rules="[val => val >= 0 || $gettext('This field value must be between positive or null')]"
                :min="0"
                :loading="loading"
                step="1"
                hide-bottom-space
                class="col"
              />
              <q-input
                v-model.number="storeIrrigationNitrogenContent"
                filled
                type="number"
                :label="$gettext('Nitrate concentration')"
                :suffix="$gettext('ppm')"
                :rules="[val => (val >= 0 && val <= 1000000) || $gettext('This field value must be between 0 and 1000000')]"
                :min="0"
                :max="1000000"
                :loading="loading"
                step="0.1"
                hide-bottom-space
                class="col"
              />
            </div>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Compute</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
      <q-dialog v-model="showClimateZonesInfo">
        <NavigatorF3ClimateZonesCard />
      </q-dialog>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryNavigatorF3Config from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/graphql/queryNavigatorF3Config'
import queryNavigatorF3ClimateZone from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/graphql/queryNavigatorF3ClimateZone'
import queryNavigatorF3WaterSupplyEnum from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/graphql/queryNavigatorF3WaterSupplyEnum'
import queryNavigatorF3IrrigationMethodEnum from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/graphql/queryNavigatorF3IrrigationMethodEnum'
import NavigatorF3ClimateZonesCard from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/components/NavigatorF3ClimateZonesCard'
import { getConversionRatio, getDisplayUnit } from 'src/services/fieldbook/fertilization/fertilizationPlan'

export default {
  name: 'NavigatorF3IrrigationPage',
  components: {
    GenericLayout,
    Header,
    Footer,
    NavigatorF3ClimateZonesCard
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      navigatorF3Config: null,
      navigatorF3ClimateZones: null,
      navigatorF3WaterSupplies: null,
      navigatorF3IrrigationMethods: null,
      showClimateZonesInfo: false
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Irrigation')
    },
    pageSubTitle () {
      return 'Navigator F3'
    },
    canContinue () {
      return this.isParameterSet(this.storeIrrigationClimateZone) &&
        this.isParameterSet(this.storeIrrigationType) &&
        this.isParameterSet(this.storeIrrigationDose) &&
        this.isParameterSet(this.storeIrrigationNitrogenContent) &&
        this.isParameterSet(this.storeIrrigationAnnualRainfall) &&
        this.isParameterSet(this.storeIrrigationAutumnWinterRainfall)
    },
    loading () {
      return !this.navigatorF3Config || !this.navigatorF3ClimateZones || !this.navigatorF3IrrigationMethods
    },
    displayUnitConfig () {
      return {
        surface: this.$store.state.fertilizationPlan.parameters.displaySurfaceUnit
      }
    },
    climateZoneOptions () {
      if (!this.navigatorF3ClimateZones) {
        return []
      } else {
        return this.navigatorF3ClimateZones.filter(zone => zone.is_active)
      }
    },
    waterSupplyOptions () {
      if (!this.navigatorF3WaterSupplies) {
        return []
      } else {
        return this.navigatorF3WaterSupplies.map(waterSupply => ({
          value: waterSupply.name,
          label: waterSupply.description
        }))
      }
    },
    irrigationTypeOptions () {
      if (!this.navigatorF3IrrigationMethods) {
        return []
      } else {
        return this.navigatorF3IrrigationMethods
      }
    },
    irrigationDoseUnitDisplay () {
      return getDisplayUnit({
        quantity: { short_name: 'm3' },
        surface: this.$store.state.fertilizationPlan.parameters.displaySurfaceUnit
      })
    },
    hasIrrigation () {
      return this.storeIrrigationWaterSupply === 'irrigated'
    },
    storeIrrigationClimateZone: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.irrigationClimateZone
      },
      set (v) {
        this.updateParameter('irrigationClimateZone', v)
      }
    },
    storeIrrigationWaterSupply: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.irrigationWaterSupply?.name
      },
      set (v) {
        const waterSupply = this.navigatorF3WaterSupplies?.find(val => val.name === v)
        this.updateParameter('irrigationWaterSupply', waterSupply)
      }
    },
    storeIrrigationType: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.irrigationType
      },
      set (v) {
        this.updateParameter('irrigationType', v)
      }
    },
    storeIrrigationDose: {
      get () {
        const irrigationDose = this.$store.state.fertilizationPlan.parameters.irrigationDose ?? null
        if (irrigationDose === null) {
          return null
        } else {
          const conversionRatio = getConversionRatio(this.displayUnitConfig)
          return irrigationDose * conversionRatio
        }
      },
      set (v) {
        let value = null
        if (v > 0) {
          const conversionRatio = getConversionRatio(this.displayUnitConfig)
          value = v / conversionRatio
        }
        this.updateParameter('irrigationDose', value)
      }
    },
    storeIrrigationNitrogenContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.irrigationNitrogenContent
      },
      set (v) {
        this.updateParameter('irrigationNitrogenContent', v)
      }
    },
    storeIrrigationAnnualRainfall: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.irrigationAnnualRainfall
      },
      set (v) {
        this.updateParameter('irrigationAnnualRainfall', v)
      }
    },
    storeIrrigationAutumnWinterRainfall: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.irrigationAutumnWinterRainfall
      },
      set (v) {
        this.updateParameter('irrigationAutumnWinterRainfall', v)
      }
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadData('cache-first')

    // Set default values from the config
    if (!this.isParameterSet(this.storeIrrigationClimateZone)) {
      this.storeIrrigationClimateZone = this.climateZoneOptions.find(zone => zone.id === this.navigatorF3Config?.default_climate_zone_id)
    }
    if (!this.isParameterSet(this.storeIrrigationAnnualRainfall)) {
      this.storeIrrigationAnnualRainfall = this.storeIrrigationClimateZone?.rainfall_annual
    }
    if (!this.isParameterSet(this.storeIrrigationAutumnWinterRainfall)) {
      this.storeIrrigationAutumnWinterRainfall = this.storeIrrigationClimateZone?.rainfall_autumn_winter
    }
    if (!this.isParameterSet(this.storeIrrigationWaterSupply)) {
      this.storeIrrigationWaterSupply = this.navigatorF3Config?.default_water_supply_method
    }
    if (!this.isParameterSet(this.storeIrrigationType)) {
      this.storeIrrigationType = this.irrigationTypeOptions.find(type => type.name === this.navigatorF3Config?.default_irrigation_method)
    }
    if (!this.isParameterSet(this.storeIrrigationDose)) {
      // bypass setter to avoid unit conversion
      this.updateParameter('irrigationDose', this.navigatorF3Config?.default_irrigation_dose)
    }
    if (!this.isParameterSet(this.storeIrrigationNitrogenContent)) {
      this.storeIrrigationNitrogenContent = this.navigatorF3Config.default_nitrogen_no3_content_in_water
    }

    // Refresh online data (do not wait until completion)
    this.loadData('network-only')
  },
  methods: {
    onClickNext () {
      // reset unused fields
      if (!this.hasIrrigation) {
        this.storeIrrigationType = null
        this.storeIrrigationDose = null
        this.storeIrrigationNitrogenContent = null
        this.storeIrrigationAnnualRainfall = null
        this.storeIrrigationAutumnWinterRainfall = null
      }
      this.$router.push({
        name: 'navigatorF3NutrientBalance'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'navigatorF3Soil'
      })
    },
    onClickClimateZoneInfo () {
      this.showClimateZonesInfo = true
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryNavigatorF3Config,
        fetchPolicy
      })
      this.navigatorF3Config = data?.navigator_f3__config
    },
    async loadClimateZones (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryNavigatorF3ClimateZone,
        fetchPolicy
      })
      this.navigatorF3ClimateZones = data?.navigator_f3__climate_zone
    },
    async loadWaterSupplies (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryNavigatorF3WaterSupplyEnum,
        fetchPolicy
      })
      this.navigatorF3WaterSupplies = data?.__type.enumValues
    },
    async loadIrrigationMethods (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryNavigatorF3IrrigationMethodEnum,
        fetchPolicy
      })
      this.navigatorF3IrrigationMethods = data?.__type.enumValues
    },
    loadData (fetchPolicy) {
      return Promise.all([
        this.loadConfig(fetchPolicy),
        this.loadClimateZones(fetchPolicy),
        this.loadWaterSupplies(fetchPolicy),
        this.loadIrrigationMethods(fetchPolicy)
      ])
    },
    onClimateZoneChange () {
      this.storeIrrigationAnnualRainfall = this.storeIrrigationClimateZone?.rainfall_annual
      this.storeIrrigationAutumnWinterRainfall = this.storeIrrigationClimateZone?.rainfall_autumn_winter
    },
    checkAutomnWinterRainfall (val) {
      return val <= this.storeIrrigationAnnualRainfall || this.$gettext('The autumn-winter rainfall must not exceed the annual rainfall')
    }
  }
}
</script>
